/* Esame di Sistemi Operativi - 10 luglio 2003 - Traccia B - Esercizio 2 */

class Cliente extends Thread {
  private int id;
  private Gelataio gelataio1;
  private Gelataio gelataio2;
  private Gelataio gelataio3;
  private int numGustiGelato = 3; // numero di gusti per gelato

  public Cliente (int id, Gelataio gelataio1, Gelataio gelataio2, Gelataio gelataio3) {
    this.id=id;
    this.gelataio1 = gelataio1;
    this.gelataio2 = gelataio2;
    this.gelataio3 = gelataio3;
  }

  public void run () {
    while (true) {

      /* attende tra una richiesta e l'altra */
      try {
	    sleep ( (int)(Math.random()*(2500)+500) );
	  } catch (InterruptedException e) { System.out.println (e); }

      /* sceglie il gelataio */
      Gelataio gelataio;
      double r = Math.random()*3.0;
      if (r < 1.0)
        gelataio = gelataio1;
      else if (r < 2.0)
        gelataio = gelataio2;
      else
        gelataio = gelataio3;

      /* sceglie i gusti del gelato */
      int gelato[] = new int[numGustiGelato];
      for (int i = 0; i < numGustiGelato; i++) {
		boolean giScelto;
		int gusto;
		do {
          /* sceglie a caso un gusto */
          gusto = (int)(Math.random()*Gusti.numGustiDisponibili);
          /* verifica che non sia uguale ad uno dei gusti gi scelti */
          giScelto = false;
          for (int j = 0; j < i && !giScelto; j++)
            if (gusto==gelato[j])
              giScelto = true;
	    } while (giScelto);
        gelato[i] = gusto;
      }

      /* chiede il gelato */
      gelataio.chiediGelato(id,gelato);

      /* consuma il gelato */
      System.out.println ("Il cliente "+id+" consuma il gelato("+
                           gelato[0]+","+gelato[1]+","+gelato[2]+")");
	}
  }
}


class Gelataio {
  private int id;
  private Gusti gusti;

  public Gelataio (int id, Gusti gusti) {
	this.id = id;
	this.gusti = gusti;
  }

  public synchronized void chiediGelato (int idCliente, int gelato[]) {
	System.out.println ("Il cliente "+idCliente+" chiede il gelato("+
	                     gelato[0]+","+gelato[1]+","+gelato[2]+") al gelataio "+id);

    while(gusti.iniziaPreparazione(gelato) == false) {
	  System.out.println ("Il gelataio "+id+" non trova uno o piu' gusti per preparare il gelato("+
		                   gelato[0]+","+gelato[1]+","+gelato[2]+")");
	  System.out.println ("Il cliente "+idCliente+" viene messo in attesa");
      try {
        wait();
	  } catch (InterruptedException e) {}
    }

    System.out.println ("Il gelataio "+id+" inizia a preparare il gelato("+
                           gelato[0]+","+gelato[1]+","+gelato[2]+") per il cliente "+idCliente);

	/* tempo di preparazione del gelato */
	try {
      Thread.sleep ( (int)(Math.random()*(1000)+1000) );
	} catch (InterruptedException e) { System.out.println (e); }

    gusti.terminaPreparazione(gelato);
    System.out.println ("Il gelataio "+id+" ha finito di preparare il gelato("+
                         gelato[0]+","+gelato[1]+","+gelato[2]+") per il cliente "+idCliente);

    notifyAll();
  }

}


class Gusti {

  public static final int numGustiDisponibili = 15;

  /* l'array seguente memorizza la disponibilit corrente dei diversi gusti */
  private boolean gusti[] = new boolean[numGustiDisponibili];

  public Gusti () {
	for (int i = 0; i < numGustiDisponibili; i++)
	  gusti[i] = true;
  }

  public synchronized boolean iniziaPreparazione (int gelato[]) {
    for (int i = 0; i < gelato.length; i++)
      if (gusti[gelato[i]] == false)
        return false;
    for (int i = 0; i < gelato.length; i++)
      gusti[gelato[i]] = false;
    return true;
  }

  public synchronized void terminaPreparazione (int gelato[]) {
    for (int i = 0; i < gelato.length; i++)
      gusti[gelato[i]] = true;
  }

}


public class Esercizio2B {

  private static final int numClienti = 10;

  public static void main (String args[]) {
    Gusti gusti = new Gusti ();
    Gelataio g1 = new Gelataio (0, gusti);
    Gelataio g2 = new Gelataio (1, gusti);
    Gelataio g3 = new Gelataio (2, gusti);
    Cliente clienti[] = new Cliente[numClienti];
    for (int i = 0; i < numClienti; i++) {
      clienti[i] = new Cliente (i,g1,g2,g3);
      clienti[i].start();
    }
  }
}